#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>

#include "daemon.h"

char  *pidfile;
int   have_tty   = 1;
int   debug      = 0;
int   dontdetach = 0;

static void pidfile_cleanup(void)
{
    unlink(pidfile);
}

void daemonize(void)
{
    char mypid[16];
    int pid;

    if (pidfile) {
	if (-1 == (pid = open(pidfile, O_WRONLY | O_CREAT | O_EXCL, 0600))) {
	    fprintf(stderr,"open %s: %s\n",pidfile,strerror(errno));
	    exit(1);
	}
    }

    if (!debug && !dontdetach) {
	/* detach from terminal */
	switch (fork()) {
	case -1:
	    perror("fork");
	    if (pidfile)
		pidfile_cleanup();
	    exit(1);
	case 0:
	    close(0); close(1); close(2);
	    setsid();
	    open("/dev/null",O_RDWR); dup(0); dup(0);
	    have_tty = 0;
	    break;
	default:
	    exit(0);
	}
    }

    if (pidfile) {
	atexit(pidfile_cleanup);
	sprintf(mypid,"%d",getpid());
	write(pid,mypid,strlen(mypid));
	close(pid);
    }
}
